
* Clustered Outcomes Chapter
drop _all

webuse ships
                                                                                                                             
glm accident op_75_79 co_65_69 co_70_74 co_75_79, family(poisson) link(log) vce(cluster ship) exposure(service) eform nolog

glm accident op_75_79 co_65_69 co_70_74 co_75_79 i.ship, family(poisson) link(log) exposure(service) eform nolog

xtset ship
xtpoisson accident op_75_79 co_65_69 co_70_74 co_75_79, fe exposure(service) eform nolog

xtpoisson accident op_75_79 co_65_69 co_70_74 co_75_79, re normal exposure(service) eform nolog skip

xtpoisson accident op_75_79 co_65_69 co_70_74 co_75_79, re exposure(service) eform nolog

generate double exposure = ln(service)
gllamm accident op_75_79 co_65_69 co_70_74 co_75_79, family(poisson) link(log) exposure(service) eform

xtpoisson accident op_75_79 co_65_69 co_70_74 co_75_79, pa exposure(service) vce(robust) eform nolog

drop _all
set seed 1239
set more off
set obs 500
generate x1 = runiform()*10
generate x2 = runiform()*5
generate x3 = runiform()
generate x4 = runiform()
generate x5 = runiform() 
generate err = rnormal()
generate y =  1*x1 + 2*x2 + 3*x3 + 4*x4 + 5 + err
generate a1 = x3 + 0.25*rnormal()
generate a2 = x3 + 0.25*rnormal()
generate b1 = x4 + 0.25*rnormal()
generate b2 = x4 + 0.25*rnormal()

glm y x1 x2 x3 x4, noheader

glm y x1 x2 a1 b1, noheader
glm y x1 x2 a2 b2, noheader

simex (y=x1 x2) (w3: a1 a2) (w4: b1 b2), brep(299) seed(12345)
