*! version 1.0.0  18aug2011
program define zigp_plf
        version 6.0
	args todo b lnf

	tempname tau	
	tempvar eta zg 
	
	mleval `eta' = `b', eq(1)
	mleval `zg'  = `b', eq(2)
	mleval `tau' = `b', eq(3) scalar


	/* Calculate the log-likelihood */

	if `tau' < -18 { scalar `tau' = -18 }
	if `tau' >  18 { scalar `tau' =  18 }

	tempname del
	scalar `del' = (exp(2*`tau')-1) / (exp(2*`tau')+1)
	local y "$ML_y1"

	tempname maxdel mindel 
	tempvar  chk
	if 0 {
		qui gen double `chk' = (exp(`eta')-`y') 
		summ `chk' if $ML_samp, meanonly
		
		scalar `mindel' = max(-1, r(min))
	
		if `mindel' > -.001 {
			scalar `mindel' = -0.001
		}
	}
	else {
		qui gen double `chk' = exp(`eta')
		scalar `mindel' = max(-1, -r(max)/4)
	}
	scalar `mindel' = `mindel' + 0.001
	scalar `maxdel' =  0.999

	if `tau' > 300 | `del' > `maxdel' {
		scalar `del' = `maxdel'
	}
	if `del' < `mindel' {
		scalar `del' = `mindel'
	}

	tempname onemd
	scalar `onemd' = 1.0 - `del'

	tempvar mu den
	qui gen double `mu' = exp(`eta')             if $ML_samp
	qui gen double `den'= `onemd'*`mu'+`del'*`y' if $ML_samp


	#delimit ;
	mlsum `lnf' = cond($ML_y1 == 0 , 
		ln(normprob(`zg') + (1-normprob(`zg'))*exp(-`onemd'*`mu')),
		ln(1-normprob(`zg'))  -`onemd'*`mu' - `del'*`y' + 
		(`y'-1)*log(`den') + `eta' + log(`onemd') - lngamma(`y'+1) ) ;
	#delimit cr 

end
